#!/usr/bin/php
<?php
//error_reporting(E_ALL ^ E_NOTICE);
//ini_set('display_errors','On');

define(BASEPATH,'/var/www/');
require_once(BASEPATH.'init.php');
require_once(BASEPATH.'cticonnect/classes/cti_db.php');

function getHash($data){
	return md5($data['username'] . $data['email'] . $data['extension'] . $data['phone'] . $data['office'] . $data['home'] . $data['home_mobile']  .
				$data['fax'] . $data['mobile'] . $data['organization'] . $data['image_url'] . $data['shortcut'] . $data['phonebook_id'] .
				$data['user_class'] . $data['note'] . $data['address'] . $data['vat_id'] . $data['name_prefix'] . $data['user_passport_type'] .
				$data['user_passport_id'] . $data['pin'] . $data['credit'] . $data['country'] . $data['date_birth'] . $data['born_in'] . $data['postal_code'] .
				$data['city'] . $data['province'] . $data['license_plate'] . $data['document_released_on'] . $data['document_from']);
}

exec('sudo ps aux | grep -c [^]]'.basename( __FILE__ ), $out);
if ((int) implode('', $out) > 1) {
	exit('Another instance of this script is already running'.PHP_EOL); // Exit due to same script already started
}

exec('/usr/sbin/wms_can_mount_to_ro', $out, $retval);
if ($retval != '0') {
    exit(); // Exit due to upgrade is started
}

$db = new \CTI\DB('/mnt/cticonnect/cticonnectdb');

//////////////////////////////////////
// get phonebook users
$query = "SELECT rid FROM cti_phonebooks WHERE type = 3";
$ldapPhonebookId = null;
if($res = $db->query($query)){
	if ($row = $res->fetchArray(SQLITE3_ASSOC)) {
		$ldapPhonebookId = $row['rid'];
	} else {
		$hash = md5('LDAP30');
		$db->exec("INSERT INTO cti_phonebooks (name, type, owner_id, hash) VALUES ('LDAP', 3, 0, '{$hash}');");
		$ldapPhonebookId = $db->lastInsertRowID();
	}
	$res->finalize();
}

if ($ldapPhonebookId === null || $ldapPhonebookId < 1){
	die('not found the phone book ID'.PHP_EOL);
}

$phoneBookUsers = array();
$duplPhoneBookUsers = array();
if($res = $db->query("SELECT extension, rid, group_id, hash FROM cti_contacts WHERE phonebook_id = {$ldapPhonebookId};")){
	while ($row = $res->fetchArray(SQLITE3_ASSOC)) {
		if (isset($phoneBookUsers[$row['extension']])){
			//For a some reason in cti_contacts appears duplicated extensions
			//for now duplicated extensions just will are deleted
			$duplPhoneBookUsers[] = $row;
		} else {
			$phoneBookUsers[$row['extension']] = $row;
		}
	}
	$res->finalize();
}
$db->disconnect();
/////////////////////////////////////
////////////////////////////////////////
// get ldap users
$ldapProps = array('cn', 'owner', 'mail', LDAP_EXTEN_NUMBER, 'facsimileTelephoneNumber', 'mobile', 'imageUrl', LDAP_OFFICE_NUMBER);

$cookie = '';
$count = 500;

$ldapConnect = WMS_Ldap::getInstance()->getConnect();
ldap_set_option($ldapConnect, LDAP_OPT_TIMELIMIT, 2);
$ldapParam = WMS_Ldap::getInstance()->getConnectParams();
$filter = "(&(objectClass=".(WMS_Ldap::PERSONS).")(|(userKind=user)(userKind=admin)(userKind=fax)(userKind=park_orbit)))";

do{
	$querys = array();

	ldap_control_paged_result($ldapConnect, $count, true, $cookie);

	$searchResult = @ldap_search($ldapConnect, $ldapParam['basedn'], $filter, $ldapProps, 0, 0, 2);
	if (!$searchResult) {
		return ldap_error($ldapConnect);
	}

	$entryID = ldap_first_entry($ldapConnect,$searchResult);

	do {
		$row = ldap_get_attributes($ldapConnect, $entryID);

		$user = array();
		foreach ($ldapProps as $attr) {

			if($attr == 'dn'){
				$user['dn'] = ldap_get_dn($ldapConnect, $entryID);
			}else{
				if(isset($row[$attr]['count'])){
					if($row[$attr]['count']==1){
						$user[$attr] = $row[$attr][0];
					}else{
						unset($row[$attr]['count']);
						$user[$attr] = $row[$attr];
					}
				}
				else{
					$user[$attr] = $row[$attr];
				}
			}
		}

		if (!isset($user[LDAP_EXTEN_NUMBER]) || !isset($user[cn])) {
			continue;
		}

		if (!isset($user['mail'])) {
			$user['mail'] = '';
		}
		if (!isset($user['facsimileTelephoneNumber'])) {
			$user['facsimileTelephoneNumber'] = '';
		}
		if (!isset($user['mobile'])) {
			$user['mobile'] = '';
		}
		if (!isset($user['imageUrl'])) {
			$user['imageUrl'] = '';
		}

		$data = array(
			    'username' => $user['cn'],
				'email' => $user['mail'],
				'extension' => $user[LDAP_EXTEN_NUMBER],
				'phone' => '',
				'office' => $user[LDAP_OFFICE_NUMBER],
				'home' => '',
				'home_mobile' => '',
				'fax' => $user['facsimileTelephoneNumber'],
				'mobile' => $user['mobile'],
				'organization' => 'LDAP',
				'image_url' => $user['imageUrl'],
				'shortcut' => '',
				'phonebook_id' => $ldapPhonebookId,
				'group_id' => $user['owner'],
				'user_class' => '',
				'note' => '',
				'address' => '',
				'vat_id' => '',
				'name_prefix' => '',
				'pin' => '',
				'credit' => '',
				'country' => '',
				'date_birth' => '',
				'born_in' => '',
				'postal_code' => '',
				'city' => '',
				'province' => '',
				'license_plate' => '',
				'document_released_on' => '',
				'document_from' => ''
		);

		$data['hash'] = getHash($data);

		if (isset($phoneBookUsers[$user[LDAP_EXTEN_NUMBER]])){
			// update
			if($phoneBookUsers[$user[LDAP_EXTEN_NUMBER]]['hash'] != $data['hash'] OR $phoneBookUsers[$user[LDAP_EXTEN_NUMBER]]['group_id'] != $user['owner']){
				$setSql = array();
				foreach($data as $key=>$value){
					$setSql[] = "{$key} = '{$db->escape($value)}'";
				}

				if(!empty($setSql)){
					$querys[] = "UPDATE cti_contacts SET ".join(", ", $setSql)." WHERE rid = {$phoneBookUsers[$user[LDAP_EXTEN_NUMBER]]['rid']};";
				}
			}

			unset($phoneBookUsers[$user[LDAP_EXTEN_NUMBER]]);
		}else{
			// insert
			$keys = array();
			$values = array();
			foreach($data as $key=>$value){
				$keys[] = $key;
				$values[] = "'{$db->escape($value)}'";
			}
			$querys[] = "INSERT INTO cti_contacts (".join(", ", $keys).") VALUES(".join(", ", $values).");";

		}

	}while ($entryID = ldap_next_entry($ldapConnect,$entryID));

	if (!empty($querys)){
		$db->connect();
		if($db->exec('BEGIN TRANSACTION;')){
			if(!$db->exec(join("\n", $querys))){
				logger("Error ({$db->lastErrorCode()}): {$db->lastErrorMsg()}", __FUNCTION__, __LINE__);
			}

			if(!$db->exec('COMMIT;')){
				logger("Error ({$db->lastErrorCode()}): {$db->lastErrorMsg()}", __FUNCTION__, __LINE__);
			}
		}else{
			logger("Error ({$db->lastErrorCode()}): {$db->lastErrorMsg()}", __FUNCTION__, __LINE__);
		}
		$db->disconnect();
	}

	ldap_control_paged_result_response($ldapConnect, $searchResult, $cookie);
	@ldap_free_result($searchResult);

} while($cookie !== null && $cookie != '');

//////////////////////////////////////
$querys = array();

$phoneBookUsers = array_merge($phoneBookUsers, $duplPhoneBookUsers);
if(!empty($phoneBookUsers)){
	$rd = array();
	foreach($phoneBookUsers as $phoneBookUser){
		$rd[] = $phoneBookUser['rid'];
	}
	$querys[] = "DELETE FROM cti_contacts WHERE rid IN ('".implode("','", $rd)."');";
}

if (!empty($querys)){
	$db->connect();
	if($db->exec('BEGIN TRANSACTION;')){
		if(!$db->exec(join("\n", $querys))){
			logger("Error ({$db->lastErrorCode()}): {$db->lastErrorMsg()}", __FUNCTION__, __LINE__);
		}

		if(!$db->exec('COMMIT;')){
			logger("Error ({$db->lastErrorCode()}): {$db->lastErrorMsg()}", __FUNCTION__, __LINE__);
		}
	}else{
		logger("Error ({$db->lastErrorCode()}): {$db->lastErrorMsg()}", __FUNCTION__, __LINE__);
	}
	$db->disconnect();
}