(function ($) { // To-do: remove after prototype removed
    var NtpSettings = function () {
        this.constructor();
    };

    NtpSettings.prototype = {
        constructor: function () {
            this.mainForm = $('#ntp_form');
            this._data = false;
        },
        load: function () {
            this.mainForm.find('#time').datetimepicker({
                dateFormat: 'dd/mm/yy',
                showMicrosec: false,
                showMillisec: false,
                timeFormat: 'HH:mm:ss',
                onSelect: function() {
                    var inputs = this.mainForm.data('wms-errors');
                    // unset previous errors
                    if (inputs) {
                        for (var id in inputs) {
                            if($(inputs[id].el).hasClass('wms-error-field')) {
                                $(inputs[id].el).tooltip('destroy').removeClass('wms-error-field');
                            }
                        }
                    }
                }.bind(this)
            });
            this.mainForm.apiForm({
                load: 'api/v1/PBX/settings/ntp/',
                submit: 'api/v1/PBX/settings/ntp/',

                beforeSubmit: function () { ap_showWaitMessage('waitDiv', 1); },
                error: function (ajaxData) { setError('error', ajaxData.reason, 5000); },
                afterSubmit: function () {
                    ap_showWaitMessage('waitDiv', 0);
                    $('.autoSync').change();
                    this.mainForm.find('#realtime').text(this.mainForm.find('#time').val());
                    this._data = this.mainForm.apiForm('option', 'loadData');
                }.bind(this)
            });

            this.mainForm.on('change', '.autoSync', $.proxy(this._onChangeNtpMode, this));

            this.mainForm.on('click', '#saveSettings', function () {
                this.sendForm();
            }.bind(this));

            this.mainForm.apiForm('load');

            /* eslint-disable */
            $(window).bind('beforeunload', $.proxy(
                function(){
                    if (this.isDirty()){
                        return WMS._t('prefs.are_you_sure_want_to_exit_without_save');
                    }
                }, this));
            /* eslint-enable */

            return this;
        },

        _onChangeNtpMode: function () {
            var disable = parseInt(this.mainForm.find('.autoSync:checked').val());
            if (!disable) {
                $('#pntp').attr('disabled', true);
                $('#sntp').attr('disabled', true);

                $('#time').removeAttr('disabled');
                $('#date').removeAttr('disabled');
            } else {
                $('#pntp').removeAttr('disabled');
                $('#sntp').removeAttr('disabled');

                $('#time').attr('disabled', true);
                $('#date').attr('disabled', true);
            }
        },
        isDirty: function(){
            var result = false;

            $.each(this.getData(), function(name, value){
                if (this._data[name] !== value){
                    result = true;
                    return false;
                }
                return true;
            }.bind(this));

            return result;
        },
        getData: function () {
            var paramObj = {};
            $.each(this.mainForm.serializeArray(), function(_, kv) {
                paramObj[kv.name] = kv.value;
            });
            return paramObj;
        },
        validateFormData: function () {
            if (!parseInt(this.mainForm.find('.autoSync:checked').val())) {
                this.mainForm.checkForm({
                    rules: [
                        'required,time,' + WMS._t('rules.CannotBeEmpty')
                    ]
                });
            } else {
                this.mainForm.checkForm({
                    rules: [
                        'required,pntp,' + WMS._t('trunks.err.HostNotFoundEnterIpOrHostname')
                    ]
                });
            }
            return this.mainForm.checkForm('validate');
        },
        sendForm: function () {
            if (this.validateFormData()) {
                this.mainForm.apiForm('submit');
            }
        }
    };

    $(document).ready(function () {
        new NtpSettings().load();
    });
})(jQuery);
